min_caml_srr_reg:
	bli r4 0  min_caml_srr_reg_neg
	addi r5 r0 31
	bg r4 r5 min_caml_srr_reg_zero
	addi r5 r0 1
	and r5 r4 r5
	bei r5 0 min_caml_srr_reg_l1
	srr r3 r3 1
min_caml_srr_reg_l1:
	addi r5 r0 2
	and r5 r4 r5
	bei r5 0 min_caml_srr_reg_l2
	srr r3 r3 2
min_caml_srr_reg_l2:
	addi r5 r0 4
	and r5 r4 r5
	bei r5 0 min_caml_srr_reg_l3
	srr r3 r3 4
min_caml_srr_reg_l3:
	addi r5 r0 8
	and r5 r4 r5
	bei r5 0 min_caml_srr_reg_l4
	srr r3 r3 8
min_caml_srr_reg_l4:
	addi r5 r0 16
	and r5 r4 r5
	bei r5 0 min_caml_srr_reg_l5
	srr r3 r3 16
min_caml_srr_reg_l5:
	jr r31
min_caml_srr_reg_neg:
	sub r4 r0 r4
	jump min_caml_sll_reg
min_caml_srr_reg_zero:
	add r3 r0 r0
	jr r31

min_caml_sll_reg:
	bli r4 0  min_caml_sll_reg_neg
	addi r5 r0 31
	bg r4 r5 min_caml_sll_reg_zero
	addi r5 r0 1
	and r5 r4 r5
	bei r5 0 min_caml_sll_reg_l1
	sll r3 r3 1
min_caml_sll_reg_l1:
	addi r5 r0 2
	and r5 r4 r5
	bei r5 0 min_caml_sll_reg_l2
	sll r3 r3 2
min_caml_sll_reg_l2:
	addi r5 r0 4
	and r5 r4 r5
	bei r5 0 min_caml_sll_reg_l3
	sll r3 r3 4
min_caml_sll_reg_l3:
	addi r5 r0 8
	and r5 r4 r5
	bei r5 0 min_caml_sll_reg_l4
	sll r3 r3 8
min_caml_sll_reg_l4:
	addi r5 r0 16
	and r5 r4 r5
	bei r5 0 min_caml_sll_reg_l5
	sll r3 r3 16
min_caml_sll_reg_l5:
	jr r31
min_caml_sll_reg_neg:
	sub r4 r0 r4
	jump min_caml_sll_reg
min_caml_sll_reg_zero:
	add r3 r0 r0
	jr r31
sin:
min_caml_sin:
	addi r4 r0 0
	jump min_caml_sincos
cos:
min_caml_cos:
	addi r4 r0 1
	jump min_caml_sincos

min_caml_sincos:
	add r5 r0 r0			#	flag_neg:r5 = 0;
	fbg r3 r0 min_caml_sincos_pos	#	if (x < 0) {
	fsub r3 r0 r3			#		x = -x;
	addi r5 r0 1			#		flag_neg = 1;
					#	}
min_caml_sincos_pos:
	addi r6 r0 16713		#	r6 = 2 * pi
	sll r6 r6 16
	addi r6 r6 4059
	fbl r3 r6 min_caml_sincos_L0	#	if (x < 2 * PI) goto RET;
	
	store r4 r1 0
	store r31 r1 1
	store r5 r1 2
	
	addi r5 r0 0xFF         #       r5: 8bit mask
	addi r6 r0 0x80         #       r6:23bit mask
	sll r6 r6 16            #
	addi r6 r6 -1		#	ex:r8, mx:r9;
	srr r8 r3 23            #	ex = ix >> 23 & 0xFFUL;
	and r8 r8 r5            #
	and r9 r3 r6            #	mx = ix & 0x7FFFFFUL | 1 << 23;
	addi r10 r0 1		#
	sll r10 r10 23		#
	or r9 r9 r10		#
	store r8 r1 3
	store r9 r1 4
	
	addi r5 r0 175
	bge r8 r5 min_caml_sincos_zero       #	if (ex >= 128 + 24 + 23) return flag_cos ? 1.0 : 0.0;

	addi r5 r0 0x7FFF	#	r5: 15bit mask

	addi r6 r0 41		#	n:r6 = 2670177
	sll r6 r6 16
	addi r6 r6 -16799

                                #	uint mx_l:r10, mx_h:r11, n_l:r12, n_h:r13;
                                #	
        and r10 r9 r5           #	mx_l = mx & 0x7FFFUL;
        srr r11 r9 15           #	mx_h = mx >> 15;
        and r12 r6 r5           #	n_l  = n  & 0x7FFFUL;
	srr r13 r6 15           #	n_h  = n  >> 15;
	store r10 r1 5
	store r11 r1 6
	store r12 r1 7
	store r13 r1 8
	
	add r3 r0 r10
	add r4 r0 r12
	addi r1 r1 9
	jal min_caml_mul	#	mul_ll = mx_l * n_l;
	subi r1 r1 9
	store r3 r1 9
	load r3 r1 5
	load r4 r1 8
	addi r1 r1 10
	jal min_caml_mul	#	mul_lh = mx_l * n_h;
	subi r1 r1 10
	store r3 r1 10
	load r3 r1 6
	load r4 r1 7
	addi r1 r1 11
	jal min_caml_mul	#	mul_hl = mx_h * n_l;
	subi r1 r1 11
	store r3 r1 11
	load r3 r1 6
	load r4 r1 8
	addi r1 r1 12
	jal min_caml_mul	#	mul_hh = mx_h * n_h;
	subi r1 r1 12
	
	load r10 r1 9		#	uint mul_ll:r10, mul_lh:r11, mul_hl:r12, mul_hh:r13;
	load r11 r1 10
	load r12 r1 11
	add r13 r0 r3
	
 				#	uint mul_tmp:r14, mul_l:r15, mul_h:r16;
	
	add r14 r11 r12		#      	mul_tmp = mul_ll + ((mul_lh + mul_hl & 0x7FFFUL) << 15);
	addi r5 r0 0x7FFF
	and r14 r14 r5
	sll r14 r14 15
	add r14 r14 r10
	
	addi r15 r0 16384	#      	mul_l = mul_tmp & 0x3FFFFFFFUL;
	sll r15 r15 16
	addi r15 r15 -1
	and r15 r15 r14
	
        srr r17 r14 30		#      	mul_h = mul_hh + (mul_lh + mul_hl >> 15) + (mul_tmp >> 30);
	add r16 r11 r12
	srr r16 r16 15
	add r16 r16 r17
	add r16 r16 r13
	
	br
	
      	#x * n̉oB
      	#2^(-23) * 2^(ex - 128) * 2^(-m)|邩A
      	#151 + m - exԖڂ23bito΂悢i͂j
      	#1.****Ƃĕ\̂ŁA1Ăŏbit̎23bitoB
      	
	load r8 r1 3
	subi r17 r8 175		#	P:r17 = 175 - ex
	sub r17 r0 r17
      				#	int i:r10;
				#      	uint ey:r11, my:r12;
				
      	subi r10 r17 1		#      	for (i = P - 1, ey = 127; i >= 0; i--, ey--)
	addi r11 r0 127
min_caml_sincos_loop:
	bl r10 r0 min_caml_sincos_loop_exit
      	
	bli r10 30 min_caml_sincos_L1	#	if (i >= 30 && i < 60)
	addi r5 r0 60
	bge r10 r5 min_caml_sincos_L1
	
	addi r3 r0 1
	subi r4 r10 30
	jal min_caml_sll_reg			# r3 = 1 << (i - 30)
	
	and r4 r3 r16
	be r4 r0 min_caml_sincos_loop_next	#	if (mul_h & 1 << (i - 30)) {
	
	subi r3 r3 1				#	my = mul_h & (1 << (i - 30)) - 1;
	and r3 r16 r3
	
	subi r4 r10 53				#	my >>= i - 53
	add r6 r0 r4
	jal min_caml_srr_reg
	add r12 r0 r3
	
	bl r6 r0 min_caml_sincos_L2	#	if (i - 30 < 23) goto L2
	
	jump min_caml_sincos_loop_exit		#	ʂ܂ŋy΂Ȃ
	
min_caml_sincos_L2:
	add r3 r0 r15				#	ʂ܂ŋy
	subi r4 r10 23
	jal min_caml_srr_reg
	or r12 r3 r12
	jump min_caml_sincos_loop_exit
	
min_caml_sincos_L1:
	addi r3 r0 1
	add r4 r0 r10
	jal min_caml_sll_reg
	and r4 r15 r3
	bei r4 0 min_caml_sincos_loop_next	#	if (mul_l & 1 << i) {		//͉30bit̒n܂
	subi r3 r3 1				#	my = mul_l & (1 << i) - 1;
	and r12 r15 r3
	add r3 r0 r12
	subi r4 r10 23
	jal min_caml_srr_reg			#	my >>= i - 23;
	add r12 r0 r3
	jump min_caml_sincos_loop_exit

min_caml_sincos_loop_next:
	subi r10 r10 1
	subi r11 r11 1
	jump min_caml_sincos_loop
	
min_caml_sincos_loop_exit:
	bl r10 r0 min_caml_sincos_zero	#	if (i < 0) return flag_cos ? 1.0 : 0.0;	

	sll r3 r11 23				#      	iy = ey << 23 | my;
	or r3 r12 r3
	
	br			##@܂ł͍sYO!!
	
	addi r6 r0 16713			#	r6 = 2 * PI
	sll r6 r6 16
	addi r6 r6 4059
      	fmul r3 r3 r6				#      	y *= (2 * L_PI);
	
	load r4 r1 0				#	flag_cos:r4
	load r31 r1 1
	load r5 r1 2				#	int s:r5 = 0;

min_caml_sincos_L0:	      	
	addi r6 r0 16585			#	r6 = PI
	sll r6 r6 16
	addi r6 r6 4059
	fbl r3 r6 min_caml_sincos_L4		#      	if (PI < y) {
	fsub r3 r3 r6				#      		y -= .5;
	subi r5 r5 1				#      		s = !s;
	sub r5 r0 r5				#      	}

min_caml_sincos_L4:
	br
	
	addi r7 r0 16457			#	r6 = PI / 2
	sll r7 r7 16	
	addi r7 r7 4059				#
	fbl r3 r7 min_caml_sincos_L5		#      	if (PI / 2 < y) {
	fsub r3 r6 r3				#      		y = .5 - y;
	bei r4 0 min_caml_sincos_L5		#      		if(flag_cos)
	subi r5 r5 1				#      			s = !s;
	sub r5 r0 r5				#      	}

min_caml_sincos_L5:
	addi r6 r0 16329			#	r6 = PI / 4
	sll r6 r6 16				#
	addi r6 r6 4059				#
	fbl r3 r6 min_caml_sincos_L6		#      	if (PI / 4 < y) {
	fsub r3 r6 r3				#      		y = .25 - y;
	subi r4 r4 1				#      		flag_cos = !flag_cos;
	sub r4 r0 r4				#      	}

min_caml_sincos_L6:
      	#float x1:r11, x2:r12, x3:r13, x4:r14, x5:r15, x6:r16, x7:r17, x8:r18, x9:r19;
	add r11 r0 r3
	
	fmul r12 r11 r11
	fmul r14 r12 r12
	fmul r16 r12 r14
	fmul r18 r14 r14
	
	bei r4 0 min_caml_sincos_sin	#	if (flag_cos)	
	
	addi r3 r0 16512
	sll r3 r3 16
	fdiv r12 r12 r3
	
	addi r3 r0 16960
	sll r3 r3 16
	fdiv r14 r14 r3
	
	addi r3 r0 17588
	sll r3 r3 16
	fdiv r16 r16 r3
	
	addi r3 r0 18334
	sll r3 r3 16
	addi r3 r3 -32768
	fdiv r18 r18 r3
	
	addi r3 r0 0x4000
	
	fsub r3 r3 r12
	fadd r3 r3 r14
	fsub r3 r3 r16
	fadd r3 r3 r18
	
	bei r5 0 min_caml_sincos_ret	#	return (s ? -1. : 1.) * (1. - x2 / 2. + x4 / 24. - x6 / 720. + x8 / 40320.);
	fsub r3 r0 r3
	jump min_caml_sincos_ret

min_caml_sincos_sin:
	fmul r13 r11 r12
	fmul r15 r12 r13
	fmul r17 r13 r14
	fmul r19 r14 r15
	
	addi r3 r0 16704
	sll r3 r3 16
	fdiv r13 r13 r3
	
	addi r3 r0 17264
	sll r3 r3 16
	fdiv r15 r15 r3
	
	addi r3 r0 17950
	sll r3 r3 16
	addi r3 r3 -32768
	fdiv r17 r17 r3
	
	addi r3 r0 18737
	sll r3 r3 16
	addi r3 r3 12288
	fdiv r19 r19 r3
	
	fsub r3 r11 r13
	fadd r3 r3 r15
	fsub r3 r3 r17
	fadd r3 r3 r19
	
	bei r5 0 min_caml_sincos_ret	#	return (s ? -1. : 1.) * (x1 - x3 / 6. + x5 / 120. - x7 / 5040. + x9 / 362880.);
	fsub r3 r0 r3
	jump min_caml_sincos_ret

min_caml_sincos_ret:
	jr r31

min_caml_sincos_zero:
	bei r4 1 min_caml_sincos_zero_cos
	add r3 r0 r0				#	return 0.0
	jr r31
min_caml_sincos_zero_cos:
	addi r3 r0 16384			#	return 1.0
	sll r3 r3 16
	jr r31
